angular.module('referrersApp', [
        'ngRoute',
        'manageProfiles',
        'referrers'
    ])
    .config(['$routeProvider',
        function ($routeProvider) {
            $routeProvider
                .when('/referrers', {
                    templateUrl: ManagersContext.localTemplatesPath + '/referrers/referrers-list.html',
                    controller: 'ReferrersListCtrl'
                })
                .when('/referrer/:referrerId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/referrers/referrer-details.html',
                    controller: 'ReferrerDetailsCtrl'
                })
                .when('/referrer/queries/:referrerId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/referrers/referrer-queries-list.html',
                    controller: 'ReferrerQueriesCtrl'
                })
                .when('/referrer/:referrerId/profile/:profileId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-view.html',
                    controller: 'ManageProfileCtrl',
                    resolve: {
                        // resolve profile here to avoid async issue using deferred API
                        "profile": function ($q, $route, profileService) {
                            var profile = $q.defer();
                            profileService.getProfile($route.current.params.profileId).success(function (profileData) {
                                profile.resolve(profileData);
                            });
                            return profile.promise;
                        }
                    }
                })
                .when('/referrer/:referrerId/profile/:profileId/:sessionId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-session.html',
                    controller: 'ManageSessionCtrl'
                })
                .otherwise({
                    redirectTo: '/referrers'
                });
        }])
;
