angular.module('manageRules', [ 'ngResource', 'condition', 'action', 'wemServices', 'wemDirectives', 'picker', 'i18n' ])
    .run(function ($rootScope) {
        $rootScope.getCurrentModuleResource = function(resourcePath) {
            return ManagersUtils.getCurrentModuleResource(resourcePath);
        };
    })

    .controller('ManageRulesListCtrl', function ($scope, $http, $location, $route, ruleService) {
        ruleService.getAll().success(function(data) {
            $scope.rules = data;
        });

        $scope.createRule = function ($event) {
            var id = ManagersUtils.generateId();
            var rule = {
                metadata: {
                    id: id,
                    name: $scope.newRuleName,
                    scope: ManagersContext.dmfScope
                },
                condition : {
                    "parameterValues": {
                        "subConditions": [
                        ],
                        "operator": "and"
                    },
                    "type": "booleanCondition"
                },
                "actions" : []
            };
            ruleService.setRule(rule).success(function(data) {
                $location.path("/rule/"+ id);
            });
        };

        $scope.deleteRule = function (id) {
            ruleService.deleteRule(id).success(function(data) {
                $route.reload()
            });
        };
    })

    .controller('ManageRulesCtrl', function ($scope, $routeParams, $location, $resource, ruleService, currentRule, definitionService) {
        var conditionTypesResource = $resource(ManagersContext.proxyServletUrl + "/cxs/definitions/conditions", {}, { 'get': {method:'GET', isArray : true  }});
        var actionTypesResource = $resource(ManagersContext.proxyServletUrl + "/cxs/definitions/actions", {}, { 'get': {method:'GET', isArray : true }});
        var tagResource = $resource(ManagersContext.proxyServletUrl + "/cxs/definitions/tags/:tagId", {tagId : "profileTags" });

        $scope.currentRule = currentRule;
        $scope.conditionTypes = [];
        $scope.actionTypes = [];

        $scope.saveRule = function ($event) {
            ruleService.setRule($scope.currentRule).success(function(){
                $location.path("/rules");
            });
        };

        $scope.tags = {};

        $scope.profileTags = tagResource.get({tagId : "profileTags"}, function(value, responseHeaders) {
            console.log("manage-rules.js : tags loaded from Apache Unomi.");

            angular.forEach(value.subTags, function(v) { $scope.tags[v.id] = v } );
            definitionService.fillTags("conditionTypes", $scope);
            definitionService.fillTags("actionTypes", $scope);
        });

        $scope.conditionTypes = conditionTypesResource.get(function (conditionTypes) {
            console.log("manage-rule.js: Loaded " + conditionTypes.length + " condition types");
        });

        $scope.actionTypes = actionTypesResource.get(function (actionTypes) {
            console.log("manage-rule.js: Loaded " + actionTypes.length + " action types");
        });

    });