<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="wem" uri="http://www.jahia.org/tags/wem" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="subchild" type="org.jahia.services.content.JCRNodeWrapper"--%>

<c:if test="${renderContext.editMode}">
    <template:addResources type="css" resources="page-perso-toolbar.css" />
    <template:addResources type="javascript" resources="wem-pagePerso-editToolbar.js" />
    <c:set var="pageNode" value="${currentNode}"/>
    <c:set var="pageVariants" value="${jcr:getChildrenOfType(pageNode, 'wemnt:pageVariant')}"/>
    <c:set var="currentVariant" value="${requestScope['currentVariant']}"/>

    <c:if test="${jcr:isNodeType(currentNode, 'wemmix:personalizedPage')}">
        <c:set var="arrowColor" value="blue"/>
    </c:if>

    <c:if test="${jcr:isNodeType(currentNode, 'wemmix:optimizationTestPage')}">
        <c:set var="arrowColor" value="green"/>
    </c:if>

    <script language="JavaScript">
        var variantsNamesArray = [];
        <c:forEach var="variant" items="${pageVariants}">
            variantsNamesArray.push('${variant.name}');
        </c:forEach>

        $(document).ready(function() {
            getIndexCurrentVariant('${currentVariant ne pageNode ? currentVariant.name : "parent"}');
            $.fn.log = function() {
                console.log.apply(console, this);
                return this;
            };
            if (window.parent.getJahiaClipboard) {
                setClipboardForPersonalizedPage(window.parent.getJahiaClipboard(), window.parent.getJahiaClipboardIsCut() ? 'cut' : 'copy');
                window.parent.addEventListener('jahia-copy', function(event) {
                    setClipboardForPersonalizedPage(event.detail.nodes, event.detail.type);
                });
            }

        });
        var toolbarStatus = "expanded";
        var showHideToolbar = function () {
            if(toolbarStatus === "expanded") {
                $("#toolbar").hide();
                $('#expandToolbar img').attr('src','<c:url value="/modules/marketing-factory-core/img/arrow_left.png"/>');
                toolbarStatus = "collapsed";
                $("div.pg-perso-toolbar").addClass('pg-perso-toolbar-light');
            } else {
                $("#toolbar").show();
                $('#expandToolbar img').attr('src','<c:url value="/modules/marketing-factory-core/img/arrow_right.png"/>');
                toolbarStatus = "expanded";
                $("div.pg-perso-toolbar").removeClass('pg-perso-toolbar-light');
            }
        }

        var setClipboardForPersonalizedPage = function (nodes,type) {
            if (nodes && nodes.length == 1 && nodes[0].nodetype == "jnt:page") {
                $("#pastePersonalizedForm input[name='path']").val(nodes[0].path)
                $("#pastePersonalizedForm input[name='type']").val(type);
                $(".pagePersonalizationPaste").css("display", "block")
            } else {
                $(".pagePersonalizationPaste").css("display", "none")
            }
        };
    </script>
    <c:set var="nbPageVariants" value="${fn:length(pageVariants) + 1}"/>

    <div class="pg-perso-toolbar">
        <div id="expandToolbar" onclick="showHideToolbar()"><img height="30px" src='<c:url value="/modules/marketing-factory-core/img/arrow_right.png"/>'/> </div>
        <div id="toolbar">
            <div class="button-placeholder x-component add-button">
                <a href="<c:url value='${url.base}${pageNode.path}.addPageVariant.do'/>" title="<fmt:message key="label.edit.perso_opti.toolbar.add"/>"><img src="<c:url value='/modules/assets/icons/jmix_droppableContent.png'/>" class="gwt-Image x-component" /><fmt:message key="label.edit.perso_opti.toolbar.add"/></a>
            </div>
            <div class="button-placeholder x-component add-button pagePersonalizationPaste" style="display: none;">
                <form id="pastePersonalizedForm" method="post" action="${url.base}${pageNode.path}.addPageVariant.do">
                    <input type="hidden" name="path"/>
                    <input type="hidden" name="type"/>
                    <a onclick="window.parent.getJahiaClipboardClear(); $('#pastePersonalizedForm').submit()" title="<fmt:message key="label.edit.perso_opti.toolbar.paste"/>">
                        <img src="<c:url value="/icons/paste.png"/>" class="gwt-Image x-component" /> <fmt:message key="label.edit.perso_opti.toolbar.paste"/>
                    </a>
                </form>
            </div>
            <div>
                <div class="x-component container-noborder">
                    <div class="x-component" style="overflow: hidden; z-index: 99999">
                        <div class="button-placeholder x-component" style="overflow: visible;">
                            <a onclick="gotoPreviousVariant('<c:url value="${url.base}${pageNode.path}.html"/>', '${currentVariant ne pageNode ? currentVariant.name : "parent"}')">
                                <img src="<c:url value="/modules/marketing-factory-core/img/arrow_left_${arrowColor}.png"/>" class="gwt-Image x-component" />
                            </a>
                        </div>
                        <div class=" button-placeholder x-component" style="overflow: visible;">
                            <span id="variantCursor"></span>
                        </div>
                        <div class="button-placeholder x-component" style="overflow: visible;">
                            <a onclick="gotoNextVariant('<c:url value='${url.base}${pageNode.path}.html'/>', '${currentVariant ne pageNode ? currentVariant.name : "parent"}')">
                                <img src="<c:url value="/modules/marketing-factory-core/img/arrow_right_${arrowColor}.png"/>" class="gwt-Image x-component" />
                            </a>
                        </div>
                    </div>
                    <c:if test="${currentVariant ne pageNode}">
                        <hr/>
                        <div class="second-line">
                            <div class="button-placeholder x-component">
                                <a href="<c:url value='${url.base}${pageNode.path}.removePageVariant.do'/>?currentVariant=${currentVariant.name}"><img src="<c:url value='/icons/delete.png'/>" class="gwt-Image x-component" title="Add page variant" /><fmt:message key="label.edit.perso_opti.toolbar.currentvar.remove"/> "<span class="title-ellipsis">${currentVariant.propertiesAsString['jcr:title']}</span>"</a>
                            </div>

                            <div class="button-placeholder x-component currentvar-button">
                                <div style="display:none;" jahiatype="module" id="moduleVaruantPage${currentVariant.identifier}" type="existingNode" path="${currentVariant.path}"></div>
                               <span id="wemEditToolbarLabel${currentVariant.identifier}" onclick="window.parent.editContent('${currentVariant.path}')"><img src="<c:url value='/icons/editAction.png'/>" class="gwt-Image x-component" title="Edit ${currentVariant.propertiesAsString['jcr:title']}" /><fmt:message key="label.edit.perso_opti.toolbar.currentvar.edit"/> "<span class="title-ellipsis">${currentVariant.propertiesAsString['jcr:title']}</span>"</span>
                            </div>
                        </div>
                    </c:if>
                </div>
            </div>
        </div>

    </div>
</c:if>